// Interface Elements header: IEResourceHandler
// Last modified 17 Jun 1997
// (c) 1997 Attila Mezei
// Do not modify this file!


#ifndef _IERESOURCEHANDLER_H_
#define _IERESOURCEHANDLER_H_



class IEResourceHandler
{

friend class IEApplication;

public:
	IEResourceHandler(entry_ref rsrcfile, BApplication *application=NULL);
	~IEResourceHandler(void);
	long Error(void);
	
	void AddResourceFile(entry_ref rsrcfile);
	void *GetResource(char *rsrcname, long *size=NULL);
	void *GetResource(long type, long *size=NULL, long index=0L);
	BView *CreateView(BMessage *config);
	BList * AddViews(BWindow *window, const char *windowname);
	void AddChildViews(BList *windowviewlist, BList *viewlist, BView *parentview, long parentID);
	void SetSizeLimits(BWindow *window, char *windowname);
	
	void AddToWindowList(BWindow *window, bool appear_in_window_menu);
	void RemoveFromWindowList(BWindow *window);
	
private:
	BApplication *application;
	
	BList *resource_list;
	BList *addon_list;
	BList *window_list;

	long errorcode;
	entry_ref rsrcfileref;
	entry_ref addondirref;
	
	BDirectory *add_on_directory;
};


#endif